package compute

import (
	"context"
	"net/http"
	"strconv"

	"repository.basistech.ru/BASIS/dynamix-golang-sdk/v15/internal/validators"
)

// MigrateToZone struct to move compute to another zone
type MigrateToZoneRequest struct {
	// ID of the compute instance to move
	// Required: true
	ComputeID uint64 `url:"computeId" json:"computeId" validate:"required"`

	// ID of the zone to move
	// Required: true
	ZoneID uint64 `url:"zoneId" json:"zoneId" validate:"required"`
}

type wrapperMigrateToZoneRequest struct {
	MigrateToZoneRequest

	AsyncMode bool `url:"asyncMode"`
}

// MigrateToZone moves compute to new zone
func (c Compute) MigrateToZone(ctx context.Context, req MigrateToZoneRequest) (bool, error) {
	err := validators.ValidateRequest(req)
	if err != nil {
		return false, validators.ValidationErrors(validators.GetErrors(err))
	}

	reqWrapped := wrapperMigrateToZoneRequest{
		MigrateToZoneRequest: req,
		AsyncMode:            false,
	}

	url := "/cloudbroker/compute/migrateToZone"

	res, err := c.client.DecortApiCall(ctx, http.MethodPost, url, reqWrapped)
	if err != nil {
		return false, err
	}

	result, err := strconv.ParseBool(string(res))
	if err != nil {
		return false, err
	}

	return result, nil
}

// MigrateToZoneAsync moves compute to new zone with AsyncMode
func (c Compute) MigrateToZoneAsync(ctx context.Context, req MigrateToZoneRequest) (string, error) {
	err := validators.ValidateRequest(req)
	if err != nil {
		return "", validators.ValidationErrors(validators.GetErrors(err))
	}

	reqWrapped := wrapperMigrateToZoneRequest{
		MigrateToZoneRequest: req,
		AsyncMode:            true,
	}

	url := "/cloudbroker/compute/migrateToZone"

	res, err := c.client.DecortApiCall(ctx, http.MethodPost, url, reqWrapped)
	if err != nil {
		return "", err
	}

	return string(res), nil
}
